// pages/may/index.js
import Notify from '@vant/weapp/notify/notify';
import { base64Encode } from '@/utils/util.js'

const app = getApp();

const env = wx.getAccountInfoSync();
const {
  envVersion
} = env.miniProgram

Page({

  /**
   * 页面的初始数据
   */
  data: {
    username: envVersion === 'develop' ? 'admin' : '',
    password: envVersion === 'develop' ? 'hs@2023' : '',
    userInfo: null
  },

  login() {
    const { username, password, userInfo } = this.data
    if (!!userInfo) {
      wx.clearStorageSync()
      return this.setData({ userInfo: null })
    }

    if (!username.trim() || !password.trim()) return Notify('输入不完整！');

    app.request('/sys/login', 'post', {
      username,
      password: base64Encode(password)
    }).then(userInfo => {
      wx.setStorageSync('userInfo', userInfo)
      this.setData({ userInfo })

      this.getUserPermission()

      Notify({ type: 'success', message: '登录成功！' });
    })
  },

  getUserPermission() {
    app.request('/sys/permission/getUserPermissionByToken', 'get', undefined, {
      successMessage: false
    }).then(permissions => {
      let { auth, menu } = permissions;

      menu = menu.find((r) => r.path === "/screen")?.children || [];
      menu = menu.length
        ? menu.map((r) => r.path.split("/").at(-1))
        : menu;

      auth = auth
        .filter((r) => r.action.startsWith("screen"))
        .map((r) => r.action);

      wx.setStorageSync('permissions', { auth, menu })
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    const userInfo = wx.getStorageSync('userInfo')
    userInfo && this.setData({ userInfo })
  },


  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})