const formatTime = date => {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()
  const hour = date.getHours()
  const minute = date.getMinutes()
  const second = date.getSeconds()

  return `${[year, month, day].map(formatNumber).join('/')} ${[hour, minute, second].map(formatNumber).join(':')}`
}

export const formatNumber = n => {
  n = n.toString()
  return n[1] ? n : `0${n}`
}

export function base64Encode(str) {
  let CHARS = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  let out = '', i = 0, len = str.length, c1, c2, c3, enc1, enc2, enc3, enc4;
  while (i < len) {
    c1 = str.charCodeAt(i++);
    c2 = str.charCodeAt(i++);
    c3 = str.charCodeAt(i++);
    enc1 = c1 >> 2;
    enc2 = ((c1 & 3) << 4) | (c2 >> 4);
    enc3 = ((c2 & 15) << 2) | (c3 >> 6);
    enc4 = c3 & 63;
    if (isNaN(c2)) {
      enc3 = enc4 = 64;
    } else if (isNaN(c3)) {
      enc4 = 64;
    }
    out += CHARS.charAt(enc1) + CHARS.charAt(enc2) + CHARS.charAt(enc3) + CHARS.charAt(enc4);
  }
  return out;
}

export function randomNum(n) {
  var res = "";
  for (var i = 0; i < n; i++) {
    res += Math.floor(Math.random() * 10);
  }
  return +res;
}
